;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "man/man_memory/entity.h.s"
.include "../main.h.s"
.include "man/man_memory/pointer_array.h.s"
.include "man_map.h.s"
.include "cpctelera.h.s"

_mapa:: .dw 0x0000
_change:: .db 0
_life:: .db 0
_floor:: .db 0 

_key_room0:: .db 0
_key_room1:: .db 0
_key_room2:: .db 0
_key_room3:: .db 0
_key_room4:: .db 0
_key_room5:: .db 0

_hearth_room0:: .db 0
_hearth_room1:: .db 0
_hearth_room2:: .db 0
_hearth_room3:: .db 0
_hearth_room4:: .db 0
_hearth_room5:: .db 0

DefineEntity doorRight,75,89,2,40,0,0,0, e_ai_st_noAI,8,98,0, 4,0
DefineEntity doorLeft, 3,89,2,40,0,0,0, e_ai_st_noAI,65,98,0, 4,0
DefineEntity doorDown, 30,189,20,3,0,0,0, e_ai_st_noAI,35,28,0, 4,0
DefineEntity doorUp, 31,24,20,3,0,0,0, e_ai_st_noAI,35,165,0, 4,0
DefineEntity wallRight,72, 32, 6, 149,0,0,0, obstacle_collision,0,0,0,3,0

;;Inicializa el mapa con el
;;primer nivel
man_map_init::
	call loadRoom0_5
	ld a, #6
	ld (_life), a

	;ld a, #0
	;ld (_keys), a

	ld a, #0
	ld (_floor), a

	;ld hl, #_level0_0
	;ld (_mapa), hl
	ret

;Creamos un jugador y asignamos su posicion
;;ENTRADA: IX -> OBSTACULO 
man_map_setPlayer::
	;Colocamos al jugador en su posicion
	ld b, e_obsPosX(ix)
    ld c, e_obsPosY(ix)
	
	push af
	ld a,(_life)
    call player_create 
	pop af
	ret

;Creamos una puerta a la izquierda
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setDoorLeft::
    push hl
    ld hl, #doorLeft
    call obstacle_createDoor
    pop hl
	call obstacle_setDoorCollision
    ret

;Creamos una puerta a la izquierda
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setDoorRight::
    push hl
    ld hl, #doorRight
    call obstacle_createDoor
    pop hl
	call obstacle_setDoorCollision
    ret

;Creamos una puerta abajo
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setDoorDown::
    push hl
    ld hl, #doorDown
    call obstacle_createDoor
    pop hl
	call obstacle_setDoorCollision
    ret

;Creamos una puerta abajo
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setDoorUp::
    push hl
    ld hl, #doorUp
    call obstacle_createDoor
    pop hl
	call obstacle_setDoorCollision
    ret

;Creamos una muralla a la derecha
man_map_setWallRight::
    ld b, #wallRight_x
	ld c, #wallRight_y
	ld d, #wallRight_w
	ld e, #wallRight_h
    call obstacle_create
	ret

;Creamos una muralla a la derecha
;partida en dos
man_map_setWallRightPartioned::
	ld b, #wallRightUp_x
	ld c, #wallRightUp_y
	ld d, #wallRightUp_w
	ld e, #wallRightUp_h
    call obstacle_create

	ld b, #wallRightDown_x
	ld c, #wallRightDown_y
	ld d, #wallRightDown_w
	ld e, #wallRightDown_h
    call obstacle_create
	ret

;Creamos una muralla a la izquierda
;partida en dos
man_map_setWallLeftPartioned::
	ld b, #wallLeftUp_x
	ld c, #wallLeftUp_y
	ld d, #wallLeftUp_w
	ld e, #wallLeftUp_h
    call obstacle_create

	ld b, #wallLeftDown_x
	ld c, #wallLeftDown_y
	ld d, #wallLeftDown_w
	ld e, #wallLeftDown_h
    call obstacle_create
	ret

;Creamos una muralla abajo
;partida en dos
man_map_setWallDownPartioned::
	ld b, #wallDownLeft_x
	ld c, #wallDownLeft_y
	ld d, #wallDownLeft_w
	ld e, #wallDownLeft_h
    call obstacle_create

	ld b, #wallDownRight_x
	ld c, #wallDownRight_y
	ld d, #wallDownRight_w
	ld e, #wallDownRight_h
   	call obstacle_create
	ret

;Creamos una muralla arriba
;partida en dos
man_map_setWallUpPartioned::
	ld b, #wallUpLeft_x
	ld c, #wallUpLeft_y
	ld d, #wallUpLeft_w
	ld e, #wallUpLeft_h
    call obstacle_create

	ld b, #wallUpRight_x
	ld c, #wallUpRight_y
	ld d, #wallUpRight_w
	ld e, #wallUpRight_h
   	call obstacle_create
	ret

;Creamos una muralla en la parte de abajo
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setWallDown::
    ld b, #wallDown_x
	ld c, #wallDown_y
	ld d, #wallDown_w
	ld e, #wallDown_h
    call obstacle_create
	ret

;Creamos una muralla en la parte de la izquierda
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setWallLeft::
    ld b, #wallLeft_x
	ld c, #wallLeft_y
	ld d, #wallLeft_w
	ld e, #wallLeft_h
    call obstacle_create
	ret

;Creamos una muralla en la parte de arriba
;;ENTRADA: IX -> OBSTACULO 
;;         DE -> FUNCION A COLISIONAR
man_map_setWallUp::
	ld b, #wallUp_x
	ld c, #wallUp_y
	ld d, #wallUp_w
	ld e, #wallUp_h
    call obstacle_create
	ret

;;Carga la room que se le pasa por parametro
;;ENTRADA: HL -> MAPA
man_map_loadRoom::
	ld (_mapa), hl
	ld a, #1
	ld (_change), a

	;Nos guardamos la vida del jugador
	push ix
	push af

	call time_clean
	ld a , #3
	ld (player_orientation), a
	
	call entityMan_getArray
	ld a, e_life(ix)
	or a
	jr z, not_set_life
	ld (_life), a

not_set_life:
	pop af
	pop ix

	call game_clearData 
	ret

;Cargamos la siguiente planta 
man_map_loadNextFloor::
	cp #0
	jr z, floor0

	cp #1
	jr z, floor1

	cp #2
	jr z, floor2

	jp _restartGame

	ret

floor0:
	ld e_obsPosX(ix), #40
    ld e_obsPosY(ix), #40
	ld a, #1

	ld (_key_room1), a
	ld (_key_room2), a
	ld (_key_room4), a
	ld (_key_room5), a
	ld (_hearth_room0), a

	ld a, #6
	ld (_life), a
	
	ld a, #0
	call loadRoom0_3

	call entityMan_getArray
	ld b, #36
	ld c, #105
	call player_setPosition
	ret
	
floor1:
	call level0Comp

	ld a, #900
complete0:
	push af
	call cpct_waitVSYNC_asm
	call cpct_waitVSYNC_asm
	call cpct_waitVSYNC_asm
	halt
	pop af

	dec a
	jr nz, complete0

	ld e_obsPosX(ix), #40
    ld e_obsPosY(ix), #40
	ld a, #1

	ld (_key_room1), a
	ld (_key_room3), a
	ld (_key_room4), a
	ld (_key_room5), a

	ld (_hearth_room0), a
	ld (_hearth_room2), a
	ld (_hearth_room4), a 
	
	ld a, #0
	call loadRoom1_0

	call entityMan_getArray
	ld b, #36
	ld c, #130
	call player_setPosition
	ret

floor2:
	call level1Comp

	ld a, #950
complete1:
	push af
	call cpct_waitVSYNC_asm
	call cpct_waitVSYNC_asm
	call cpct_waitVSYNC_asm
	halt
	pop af

	dec a
	jr nz, complete1

	ld a, #1
	ld e_obsPosX(ix), #40
	ld e_obsPosY(ix), #40
	ld (_key_room1), a
	ld (_key_room2), a
	ld (_key_room3), a
	ld (_key_room5), a
	ld (_hearth_room0), a
	ld (_hearth_room5), a

	ld a, #0
	call loadRoom2_4
	call entityMan_getArray
	ld b, #36
	ld c, #105
	call player_setPosition
	ret

_restartGame:

	call level2Comp

	ld a, #900
complete2:
	push af
	call cpct_waitVSYNC_asm
	call cpct_waitVSYNC_asm
	call cpct_waitVSYNC_asm
	halt
	pop af

	dec a
	jr nz, complete2

	ld a, #0
	ld (_floor), a

	ld a, #0
	ld (_keys),a

	call game_clearData 
	call man_map_loadNextFloor
	ret	