;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

;;Public Functions
.globl entityMan_getArray
.globl entityMan_getNum
.globl entityMan_create

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;TIPOS(CADA UN TIPO DE ENTIDAD)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 0 = PLAYER
; 1 = ENEMIGO
; 2 = PROYECTIL

.macro DefineDefaultEntity _x, _y, _w, _h, _sprite, _vx, _vy, _aist, _offsetW, _offsetH, _colision, _type, _spriteDel
    .db _x
    .db _y
    .db _w
    .db _h
    .dw _sprite
    .db _vx
    .db _vy
    .dw #0x8CCC ; Ultima posicion de memoria dibujada 
    .db 0x00,0x00 ;;AI-aim (ai_aim_x, ai_aim_y)
    .db _aist ;,AI-status si vale 0 no tiene IA
    .db _aist ;;AI- previus status
    .dw 0x0000 ;;Next ai patrol step
    .dw sys_ai_stand_by
    .dw 0x0000 ;Render pointer
    .dw 0x0000 ;Physics pointer
    .dw 0x0000 ;IA pointer
    .db _offsetW
    .db _offsetH
    .dw _colision ;;Funcion a la que llamar cuando colisiona
    .db _type
    .db _x
    .db _y
    .db _x
    .db _y
    .db 0x05
    .db 0x00
    .db 0x00
    .db 0x00
    .dw _spriteDel
.endm

.macro DefineEntity _name,_x, _y, _w, _h, _sprite, _vx, _vy, _aist, _offsetW, _offsetH,_colision,_type,_spriteDel  
_name:
    DefineDefaultEntity _x, _y, _w, _h, _sprite, _vx, _vy, _aist, _offsetW, _offsetH,_colision,_type,_spriteDel
.endm

e_x = 0
e_y = 1
e_w = 2
e_h = 3
e_sprite_l = 4
e_sprite_h = 5
e_vx = 6
e_vy = 7
e_lastVP_l = 8
e_lastVP_h = 9
e_ai_aim_x = 10
e_ai_aim_y = 11
e_ai_st = 12
e_ai_prev_st = 13
e_ai_patrol_step_l = 14
e_ai_patrol_step_h = 15
e_ai_function_l = 16
e_ai_function_h = 17
e_render_l = 18
e_render_h = 19
e_physics_l = 20
e_physics_h = 21
e_ia_l = 22
e_ia_h = 23
e_obsPosX = 24
e_obsPosY = 25
e_offsetW = 24
e_offsetH = 25
e_colision_l = 26
e_colision_h = 27
e_type = 28
e_prevX = 29
e_prevY = 30
e_prevPrevX = 31
e_prevPrevY = 32
e_life = 33
e_direction = 34
e_counterIA = 35
e_keyRoom = 35
e_hearthRoom = 35
e_draw = 36
e_spriteDel_l = 37
e_spriteDel_h = 38

;;Entity size
sizeof_e = 39

;;Entity  AI-status enum
e_ai_st_noAI = 0
e_ai_st_stand_by = 1
e_ai_st_move_to = 2
e_ai_st_patrol = 3
e_ai_st_attack_multiple = 4
e_ai_st_attack_direction = 5
.macro DefineArrayEntity _name, _N
_name::
    .rept _N
        DefineDefaultEntity 0,0,0,0,0,1,1,e_ai_st_noAI,0,0,0,0,0
    .endm
.endm