;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "type.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;COMPARA SI DOS TIPOS SON IGUALES
;;ENTRADA-> a(PRIMER TIPO A COMPARAR)
;;          b(SEGUNDO TIPO A COMPARAR)
;;
;;SALIDA-> a = 0(IGUALES)
;;         a = 1(DIFERENTES)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
type_compare::
    cp b
    jr nz, not_zero
set_zero:
    ld a, #0
    ret
not_zero:
    ld a, #1
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;COMPRUEBA SI LA ENTIDAD ES EL JUGADOR
;;ENTRADA-> a(PRIMER TIPO A COMPARAR)
;;
;;SALIDA-> a = 0(ES EL JUGADOR)
;;         a = 1(NO ES EL JUGADOR)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
type_checkPlayer::
    ld b, #TYPE_PLAYER
    call type_compare
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;COMPRUEBA SI LA ENTIDAD ES UN PROYECTIL
;;ENTRADA-> a(PRIMER TIPO A COMPARAR)
;;
;;SALIDA-> a = 0(ES UN PROYECTIL)
;;         a = 1(NO ES UN PROYECTIL)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
type_checkProjectile::
    ld b, #TYPE_PROJECTILE
    call type_compare
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;COMPRUEBA SI LA ENTIDAD ES UN OBSTACULO
;;ENTRADA-> a(PRIMER TIPO A COMPARAR)
;;
;;SALIDA-> a = 0(ES UN OBSTACULO)
;;         a = 1(NO ES UN OBSTACULO)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
type_checkObstacle::
     ld b, #TYPE_OBSTACLE
    call type_compare
    ret

type_checkEnemy::
    ld b, #TYPE_ENEMY
    call type_compare
    ret
