;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "man/man_memory/entity.h.s"
.include "man/man_memory/pointer_array.h.s"

counter_ia_val = 8

player_orientation:: .db 0 ;(0 -> Left)  (1 -> Up) (2 -> Right) (3 -> Down)

player_setDownAnimation::
    push af
    ld a, #3
    ld (player_orientation), a
    pop af

    ld hl,#_pj_sp_0
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h 
    ret

player_setUpAnimation::
    push af
    ld a, #1
    ld (player_orientation), a
    pop af

    ld hl,#_pj_sp_1
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret

player_setRightAnimation::
    push af
    ld a, #2
    ld (player_orientation), a
    pop af
    

    ld hl,#_pj_sp_3
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret

player_setLeftAnimation::
    push af
    ld a, #0
    ld (player_orientation), a
    pop af

    ld hl,#_pj_sp_2
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret


;;Pone la animacion correspondiente a un enemigo
;;ENTRADA -> ix(enemigo)
enemy_setAnimation::
    ld a, e_counterIA(ix)
    or a 
    jr nz, decCounterIA

    ld a, e_vx(ix)
    or a 
    jr z, enemy_setAnimationY

enemy_setAnimationX: 
    bit 7, a
    jr z, enemy_positiveX
    call enemy_setLeftAnimation
    ret

enemy_positiveX:
    call enemy_setRightAnimation
    ret

enemy_setAnimationY:
    ld a, e_vy(ix)
    or a
    ret z

	bit 7, a
    jr z, enemy_positiveY
    call enemy_setDownAnimation
    ret

enemy_positiveY:
    call enemy_setUpAnimation
    ret

enemy_setLeftAnimation::
    ld hl,#_enemy_sp_3
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret

enemy_setRightAnimation::
    ld hl,#_enemy_sp_2
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret

enemy_setUpAnimation::
    ld hl,#_enemy_sp_0
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret

enemy_setDownAnimation::
    ld hl,#_enemy_sp_1
    ld e_sprite_l(ix), l
    ld e_sprite_h(ix), h
    ret

decCounterIA::
    dec a
    ld e_counterIA(ix), a
    ret

;;Cambia la animacion de un enemigo parado 
;;Entrada IX -> enemigo
;;Entrada D -> direccion
enemyStand_setAnimation::
    ld a, d

    cp #1
	jr z, enemy_setLeftAnimation
	;Left
	cp #2
	jr z, enemy_setDownAnimation
	;Right
	cp #3
	jr z, enemy_setRightAnimation
	cp #4
	jr z, enemy_setUpAnimation
    ret




;;Reinicia el valor del contador de animacion
;;ENTRADA -> IX(ENEMIGO)
enemy_setCounterIA::
    ld a, #counter_ia_val
    ld e_counterIA(ix), a
	ret


