;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "menu.h.s"
.include "main.h.s"

jackstrad:: .asciz "JACKSTRAD IS"
dead:: .asciz "DEAD"
level0CompString:: .asciz "LEVEL 0"
level1CompString:: .asciz "LEVEL 1"
level2CompString:: .asciz "FREE"
completeString:: .asciz "COMPLETE"
death:: .asciz "DEATHS: "
plantString1:: .asciz "GRONF GRONF"
plantString2:: .asciz "MMMMHHHH!!"
death_num_string:: .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

;;Menu correspondiente a los controles
gameOver::
	call loadRoomMenu2

	call render_back
	call render_switchBuffer
	call render_back
	call render_switchBuffer

   ld de, #death_num_string
   ld h, #0
   ld a, (num_dead)
   ld l, a
   call Num2Dec

	;; Control
   ;;------------------
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #jackstrad
   call _myDrawStringM0

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #dead
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #jackstrad
   call _myDrawStringM0

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #dead
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer
   ret

level0Comp::
   call loadRoomMenu2

   call render_back
   call render_switchBuffer
   call render_back
   call render_switchBuffer

   ld de, #death_num_string
   ld h, #0
   ld a, (num_dead)
   ld l, a
   call Num2Dec

   ;; Control
   ;;------------------
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #level0CompString
   call _myDrawStringM0

   
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #completeString
   call _myDrawStringM0


    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #level0CompString
   call _myDrawStringM0
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #completeString
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer
   ret

level1Comp::
   call loadRoomMenu2

   call render_back
   call render_switchBuffer
   call render_back
   call render_switchBuffer

   ld de, #death_num_string
   ld h, #0
   ld a, (num_dead)
   ld l, a
   call Num2Dec

   ;; Control
   ;;------------------
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #level1CompString
   call _myDrawStringM0

   
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #completeString
   call _myDrawStringM0


    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press
   call _myDrawStringM0

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #160                  ;; B = y coordinate (y = 190)
   ld    c, #13                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press2
   call _myDrawStringM0
   call render_switchBuffer
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #level1CompString
   call _myDrawStringM0
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #completeString
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer

   ret

level2Comp::
   call loadRoomMenu2

   call render_back
   call render_switchBuffer
   call render_back
   call render_switchBuffer

   ld de, #death_num_string
   ld h, #0
   ld a, (num_dead)
   ld l, a
   call Num2Dec

   ;; Control
   ;;------------------
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #jackstrad
   call _myDrawStringM0

   
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #level2CompString
   call _myDrawStringM0


    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #70                  ;; B = y coordinate (y = 10)
   ld    c, #16                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #jackstrad
   call _myDrawStringM0
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #90                  ;; B = y coordinate (y = 10)
   ld    c, #32                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #level2CompString
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death
   call _myDrawStringM0

    ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #150                  ;; B = y coordinate (y = 190)
   ld    c, #45                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #death_num_string
   call _myDrawStringM0
   call render_switchBuffer
   ret

;;Menu correspondiente a los controles
plantScreen::
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;DRAW STRING 2
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #100                 ;; B = y coordinate (y = 190)
   ld    c, #25                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #plantString1
   call _myDrawStringM0
   call render_switchBuffer

   ;DRAW STRING 3
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #100                 ;; B = y coordinate (y = 190)
   ld    c, #25                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #plantString2
   call _myDrawStringM0
   call render_switchBuffer

   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #110                 ;; B = y coordinate (y = 190)
   ld    c, #25                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ;DRAW STRING 4
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0
   ld    b, #110                 ;; B = y coordinate (y = 190)
   ld    c, #25                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #plantString2
   call _myDrawStringM0
   call render_switchBuffer
   


   ret

Num2Dec:
	ld	bc,#-10000
	call	Num1
	ld	bc,#-1000
	call	Num1
	ld	bc,#-100
	call	Num1
	ld	c,#-10
	call	Num1
	ld	c,b

Num1:	
   ld	a,#'0'-1
Num2:
	inc	a
	add	hl,bc
	jr	c,Num2
	sbc	hl,bc

	ld	(de),a
	inc	de
	ret