;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "man/man_memory/entity.h.s"
.include "cpctelera.h.s"

DefineEntity hearth_interface,0,0,6,12,_hearthInterface_sp_0,1,1, e_ai_st_stand_by, 0,0,0, 1,_hearth_sp_1
DefineEntity life,0,2,8,8, _life_sp,0,0, e_ai_st_stand_by, 0,0,0, 1,0
DefineEntity key_letter,0,2,10,6,_key_letter_sp,1,1, e_ai_st_stand_by, 0,0,0, 1,0
DefineEntity key_interface,5,20,4,16,_keyInterface_sp_0,0,0, e_ai_st_stand_by, 0,0,0, 1,_key_sp_1

drawLife::
    call entityMan_getArray
    ld a, e_life(ix)
    or a
    ret z

    ld b, #10
    ld c, #1

    ld ix, #hearth_interface
    call player_setPosition

loop:
    call player_setPosition
    push af
    push bc
    call render_draw
    pop bc
    pop af
    
    push af
    ld a, b
    add a, #6
    ld b, a
    pop af

    dec a
    jr nz, loop
ret

drawKeys::
    call entityMan_getArray
    ld a, (_keys)
    or a
    ret z

    ld b, #60
    ld c, #0

    ld ix, #key_interface
    call player_setPosition

loop_keys:
    call player_setPosition
    push af
    push bc
    call render_draw
    pop bc
    pop af
    
    push af
    ld a, b
    add a, #5
    ld b, a
    pop af

    dec a
    jr nz, loop_keys
ret

drawLetter::
    ld b, #0
    ld c, #3
    ld ix, #life
    call player_setPosition
    call render_draw
    ret

drawLetterKey::
    ld b, #48
    ld c, #4
    ld ix, #key_letter
    call player_setPosition
    call render_draw
    ret

interface_draw::
    ;Draw interface(1st time)
    call interface_clean
    call drawLetter
    call drawLife
    call drawLetterKey
    call drawKeys

    ;Switch buffer
    call render_switchBuffer
    
    ;Draw interface(2nd time)
    call interface_clean
    call drawLetter
	call drawLife
    call drawLetterKey
    call drawKeys
	call render_switchBuffer
    ret

interface_clean::
    ;;Cargo el buffer
    ld a,(back_buffer)
    ld d,a
    ld e, #0
    ld c, #0
    ld b, #0
    call cpct_getScreenPtr_asm

    ;;Cargo el sprite
    ex de, hl
    ld a, #15
    ld b, #14
    ld c, #50 
    call cpct_drawSolidBox_asm
ret