;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "menu.h.s"
.include "main.h.s"

title: .asciz "  JACKSTRAD "
margen: .asciz "----------"
start: .asciz "1.START"
controls: .asciz "2.CONTROLS"
credits: .asciz "3.CREDITS"
write_press:: .asciz "PRESS ANY KEY"
write_press2:: .asciz ""
move: .asciz "CONTROLS"

left_move: .asciz "O: MOVE LEFT"
right_move: .asciz "P: MOVE RIGHT"
up_move: .asciz "Q: MOVE UP"
down_move: .asciz "A: MOVE DOWN"
attack: .asciz "SPACE: ATTACK"


c_first: .asciz "CREDITS"
c_audio: .asciz "SONG BY MCKLAIN"
c_programmers: .asciz "PROGRAMMERS:"
c_ferran: .asciz "FERRAN PEREZ"
c_banuls: .asciz "ALEX BANULS"
c_dani: .asciz "DANIEL MARTINEZ"



;;Menu general
getMenu::
   call loadRoomMenu
   call render_back
   call render_switchBuffer
   call render_back
   call render_switchBuffer

   ;; TITLE
   ;;------------------
   ;call loadRoom0
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #60                  ;; B = y coordinate (y = 30)
   ld    c, #14                  ;; C = x coordinate (x = 20)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #title
   call _myDrawStringM0

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #60                  ;; B = y coordinate (y = 40)
   ld    c, #20                  ;; C = x coordinate (x = 20)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;; 1. START GAME
   ;;------------------

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #100                  ;; B = y coordinate (y = 80)
   ld    c, #20                  ;; C = x coordinate (x = 25)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ;; Print the string in video memory
   ;; HL already points to video memory, as it is the return
   ;; value from cpct_getScreenPtr_asm
   ld   iy, #start    ;; IY = Pointer to the string 
   call _myDrawStringM0  ;; Draw the string

   ;; 2. CONTROLS
   ;;-----------------

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #120                 ;; B = y coordinate (y = 100)
   ld    c, #20                  ;; C = x coordinate (x = 25)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld   iy, #controls    ;; IY = Pointer to the string
   call _myDrawStringM0  ;; Draw the string

   ;; 3. CREDITS
   ;;--------------------

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #140                  ;; B = y coordinate (y = 120)
   ld    c, #20                  ;; C = x coordinate (x = 25)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld   iy, #credits    ;; IY = Pointer to the string
   call _myDrawStringM0  ;; Draw the string
   call render_switchBuffer
    ;; TITLE
   ;;------------------
   ;call loadRoom0
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #60                  ;; B = y coordinate (y = 30)
   ld    c, #14                  ;; C = x coordinate (x = 20)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #title
   call _myDrawStringM0

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #60                  ;; B = y coordinate (y = 40)
   ld    c, #20                  ;; C = x coordinate (x = 20)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;; 1. START GAME
   ;;------------------

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #100                  ;; B = y coordinate (y = 80)
   ld    c, #20                  ;; C = x coordinate (x = 25)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ;; Print the string in video memory
   ;; HL already points to video memory, as it is the return
   ;; value from cpct_getScreenPtr_asm
   ld   iy, #start    ;; IY = Pointer to the string 
   call _myDrawStringM0  ;; Draw the string

   ;; 2. CONTROLS
   ;;-----------------

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #120                 ;; B = y coordinate (y = 100)
   ld    c, #20                  ;; C = x coordinate (x = 25)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld   iy, #controls    ;; IY = Pointer to the string
   call _myDrawStringM0  ;; Draw the string

   ;; 3. CREDITS
   ;;--------------------

   ;; Calculate a video-memory location for printing a string
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #140                  ;; B = y coordinate (y = 120)
   ld    c, #20                  ;; C = x coordinate (x = 25)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld   iy, #credits    ;; IY = Pointer to the string
   call _myDrawStringM0  ;; Draw the string
   call render_switchBuffer
   ret

;;Menu correspondiente a los controles
getControl::
   call loadRoomMenu2
   call render_back
   call render_switchBuffer
   call render_back
   call render_switchBuffer

	;; Control
   ;;------------------

   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #3                  ;; B = y coordinate (y = 10)
   ld    c, #24                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #move
   call _myDrawStringM0

   ;;Press any key to continue
   ;;------------------
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue)
   ld    l, #13         ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #160                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press
   call _myDrawStringM0

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #170                  ;; B = y coordinate (y = 190)
   ld    c, #13                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press2
   call _myDrawStringM0

   
   ;;Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;;UP MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #45                  ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #up_move
   call _myDrawStringM0

   ;;LEFT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #65                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #left_move
   call _myDrawStringM0

   ;DOWN MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #85                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #down_move
   call _myDrawStringM0

   ;RIGHT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #105                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #right_move
   call _myDrawStringM0

   ;ATTACK
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #125                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #attack
   call _myDrawStringM0
   call render_switchBuffer
    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #3                  ;; B = y coordinate (y = 10)
   ld    c, #24                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #move
   call _myDrawStringM0

   ;;Press any key to continue
   ;;------------------
   ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue)
   ld    l, #13         ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #160                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press
   call _myDrawStringM0

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #170                  ;; B = y coordinate (y = 190)
   ld    c, #13                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press2
   call _myDrawStringM0

   
   ;;Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   ;;UP MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #45                  ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #up_move
   call _myDrawStringM0

   ;;LEFT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #65                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #left_move
   call _myDrawStringM0

   ;DOWN MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #85                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #down_move
   call _myDrawStringM0

   ;RIGHT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #105                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #right_move
   call _myDrawStringM0

   ;ATTACK
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #125                 ;; B = y coordinate (y = 190)
   ld    c, #15                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #attack
   call _myDrawStringM0
   call render_switchBuffer
   ret

getCredits::
   call loadRoomMenu2
   call render_back
   call render_switchBuffer
   call render_back
   call render_switchBuffer

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #3                  ;; B = y coordinate (y = 10)
   ld    c, #26                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_first
   call _myDrawStringM0


   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #160                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press
   call _myDrawStringM0

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #170                  ;; B = y coordinate (y = 190)
   ld    c, #13                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press2
   call _myDrawStringM0

   

   ;;UP MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #45                  ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_programmers
   call _myDrawStringM0

   ;;Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
   ;;LEFT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #65                 ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_banuls
   call _myDrawStringM0

   ;DOWN MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #85                 ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_dani
   call _myDrawStringM0

   ;RIGHT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #105                 ;; B = y coordinate (y = 190)
   ld    c, #11                ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_ferran
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
   ;ATTACK
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #130                 ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_audio
   call _myDrawStringM0
   call render_switchBuffer

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #3                  ;; B = y coordinate (y = 10)
   ld    c, #26                 ;; C = x coordinate (x = 32)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_first
   call _myDrawStringM0


   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #160                  ;; B = y coordinate (y = 190)
   ld    c, #13                  ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press
   call _myDrawStringM0

   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #170                  ;; B = y coordinate (y = 190)
   ld    c, #13                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #write_press2
   call _myDrawStringM0

   

   ;;UP MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #45                  ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_programmers
   call _myDrawStringM0

   ;;Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #14        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
   ;;LEFT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #65                 ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_banuls
   call _myDrawStringM0

   ;DOWN MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #85                 ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_dani
   call _myDrawStringM0

   ;RIGHT MOVE
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #105                 ;; B = y coordinate (y = 190)
   ld    c, #11                ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_ferran
   call _myDrawStringM0

    ;; Set up draw char colours before calling draw string
   ld    h, #10         ;; D = Background PEN (0 = blue
   ld    l, #13        ;; E = Foreground PEN (2 = cian)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours
   ;ATTACK
   
   ld   a, (back_buffer) ;; DE = Pointer to start of the screen
   ld d, a
   ld    e, #0 ;; DE = Pointer to start of the screen
   ld    b, #130                 ;; B = y coordinate (y = 190)
   ld    c, #11                 ;; C = x coordinate (x = 24)
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ld iy, #c_audio
   call _myDrawStringM0
   call render_switchBuffer

   ret