;;----------------------------------------LICENSE NOTICE----------------------------------------
;;  Code & Gfx Copyright (C) 2019 ByteCode Studios (@ByteCodeStudios)
;;  Music (C) 2019 McKlain (@elmcklain)
;;  This file is part of Jackstrad: an Amstrad CPC Game made with CPCTelera
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;----------------------------------------------------------------------------------------------

.include "man/man_memory/entity.h.s"
.include "man/man_memory/pointer_array.h.s"

;;SISTEMA DE FISICAS
screen_width = 80
screen_height = 200

neg_x:: .db 0
neg_y:: .db 0

physics_init::
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;MUEVE UNA ENTIDAD SEGUN SU VELOCIDAD
;;REGISTROS DESTRUIDOS: a
;;ENTRADA:
;;      ix -> Puntero que contiene la entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
physics_move::
;;Actualizar x
    ld a, #screen_width + 1
    sub e_w(ix)
    ld c, a

    ld a, e_x(ix)
    add a, e_vx(ix)
    cp c
    jr nc, invalid_x

    ld b, a
    ld a, (neg_x)
    or a
    jr nz, invalid_x

valid_x:
    ld a, b
    ld e_x(ix),a
    jr end_x

invalid_x:
    ld a, e_vx(ix)
    neg
    ld e_vx(ix),a
    ld a, #0
    ld (neg_x), a
    
end_x:
;;Actualizar y
    ld a, #screen_height + 1
    sub e_h(ix)
    ld c, a

    ld a, e_y(ix)
    add a, e_vy(ix)
    cp c
    jr nc, invalid_y

    ;Comprobamos que la y funciona
    ld b, a
    ld a, (neg_y)
    or a
    jr nz, invalid_y
    
valid_y:
    ld a, b
    ld e_y(ix),a
    jr end_y

invalid_y:
    ld a, e_vy(ix)
    neg
    ld e_vy(ix),a
    ld a, #0
    ld (neg_y), a
end_y:
    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;APLICA VELOCIDAD A TODAS LAS ENTIDADES
;;REGISTROS DESTRUIDOS: a
;;ENTRADA:
;;      ix -> Puntero que contiene la entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
physics_update::
    ;;Obtengo el numero de entidades, a->número entidades
    call man_physics_getNum
    or a
	ret z
    
    call man_physics_getArray

_physicsloop:
    push ix
    push af

    ;Obtiene la entidad donde apunta
    call man_physics_getEntity
    call physics_move
    pop af
    pop ix
    
    dec a

    ld bc,#sizeof_pointer
    add ix,bc
    jr nz,_physicsloop
    
    ret
